package me.msoucy.ptures.view

import me.msoucy.ptures.model.Creature
import me.msoucy.ptures.model.Skill
import me.msoucy.ptures.model.VisibleStatus

class SkillViewText(val skill : Skill) : SkillView() {
    override fun display() {
        println(skill.name)
    }

    override fun displayEnumerated(idx: Int) {
        println("${idx}: ${skill.name}")
    }
}

class CreatureViewText(val creature : Creature) : CreatureView() {

    private val skillViews = creature.skills.map { SkillViewText(it) }

    override val skillChoice : Skill get() {
        println("Skills:")
        println("=======")
        skillViews.forEachIndexed { index, skillView ->
            skillView.displayEnumerated(index)
        }
        var idx = -1
        while(idx != -1) {
            print("> ")
            val tmpIdx = readLine()?.toIntOrNull() ?: -1
            if (tmpIdx in creature.skills.indices)
            {
                idx = tmpIdx
            }
        }

        return creature.skills[idx]
    }

    override fun displayName() {
        println(creature.name)
    }

    override fun displaySkills() {
        skillViews.forEach { skillView ->
            skillView.display()
        }
    }

    override fun displayStatuses() {
        creature.statuses.filterIsInstance<VisibleStatus>().forEach {
            println(it.label)
        }
    }
}